//
//  LessClassicMenu.swift
//  Less Classic Menu
//
//  Created by David Moon on 1/30/21.
//  This program is licensed under a
//  <a rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">
//  Creative Commons Attribution-ShareAlike 4.0 International License</a>.
//

import Cocoa

let selectors = [
    #selector(AppDelegate.openitem0),
    #selector(AppDelegate.openitem1),
    #selector(AppDelegate.openitem2),
    #selector(AppDelegate.openitem3),
    #selector(AppDelegate.openitem4),
    #selector(AppDelegate.openitem5),
    #selector(AppDelegate.openitem6),
    #selector(AppDelegate.openitem7),
    #selector(AppDelegate.openitem8),
    #selector(AppDelegate.openitem9),
    #selector(AppDelegate.openitem10),
    #selector(AppDelegate.openitem11),
    #selector(AppDelegate.openitem12),
    #selector(AppDelegate.openitem13),
    #selector(AppDelegate.openitem14),
    #selector(AppDelegate.openitem15),
    #selector(AppDelegate.openitem16),
    #selector(AppDelegate.openitem17),
    #selector(AppDelegate.openitem18),
    #selector(AppDelegate.openitem19),
    #selector(AppDelegate.openitem20),
    #selector(AppDelegate.openitem21),
    #selector(AppDelegate.openitem22),
    #selector(AppDelegate.openitem23),
    #selector(AppDelegate.openitem24),
    #selector(AppDelegate.openitem25),
    #selector(AppDelegate.openitem26),
    #selector(AppDelegate.openitem27),
    #selector(AppDelegate.openitem28),
    #selector(AppDelegate.openitem29),
    #selector(AppDelegate.openitem30),
    #selector(AppDelegate.openitem31),
    #selector(AppDelegate.openitem32),
    #selector(AppDelegate.openitem33),
    #selector(AppDelegate.openitem34),
    #selector(AppDelegate.openitem35),
    #selector(AppDelegate.openitem36),
    #selector(AppDelegate.openitem37),
    #selector(AppDelegate.openitem38),
    #selector(AppDelegate.openitem39),
    #selector(AppDelegate.openitem40),
    #selector(AppDelegate.openitem41),
    #selector(AppDelegate.openitem42),
    #selector(AppDelegate.openitem43),
    #selector(AppDelegate.openitem44),
    #selector(AppDelegate.openitem45),
    #selector(AppDelegate.openitem46),
    #selector(AppDelegate.openitem47),
    #selector(AppDelegate.openitem48),
    #selector(AppDelegate.openitem49),
    #selector(AppDelegate.openitem50),
    #selector(AppDelegate.openitem51),
    #selector(AppDelegate.openitem52),
    #selector(AppDelegate.openitem53),
    #selector(AppDelegate.openitem54),
    #selector(AppDelegate.openitem55),
    #selector(AppDelegate.openitem56),
    #selector(AppDelegate.openitem57),
    #selector(AppDelegate.openitem58),
    #selector(AppDelegate.openitem59),
    #selector(AppDelegate.openitem60),
    #selector(AppDelegate.openitem61),
    #selector(AppDelegate.openitem62),
    #selector(AppDelegate.openitem63),
    #selector(AppDelegate.openitem64),
    #selector(AppDelegate.openitem65),
    #selector(AppDelegate.openitem66),
    #selector(AppDelegate.openitem67),
    #selector(AppDelegate.openitem68),
    #selector(AppDelegate.openitem69),
    #selector(AppDelegate.openitem70),
    #selector(AppDelegate.openitem71),
    #selector(AppDelegate.openitem72),
    #selector(AppDelegate.openitem73),
    #selector(AppDelegate.openitem74),
    #selector(AppDelegate.openitem75),
    #selector(AppDelegate.openitem76),
    #selector(AppDelegate.openitem77),
    #selector(AppDelegate.openitem78),
    #selector(AppDelegate.openitem79),
    #selector(AppDelegate.openitem80),
    #selector(AppDelegate.openitem81),
    #selector(AppDelegate.openitem82),
    #selector(AppDelegate.openitem83),
    #selector(AppDelegate.openitem84),
    #selector(AppDelegate.openitem85),
    #selector(AppDelegate.openitem86),
    #selector(AppDelegate.openitem87),
    #selector(AppDelegate.openitem88),
    #selector(AppDelegate.openitem89),
    #selector(AppDelegate.openitem90),
    #selector(AppDelegate.openitem91),
    #selector(AppDelegate.openitem92),
    #selector(AppDelegate.openitem93),
    #selector(AppDelegate.openitem94),
    #selector(AppDelegate.openitem95),
    #selector(AppDelegate.openitem96),
    #selector(AppDelegate.openitem97),
    #selector(AppDelegate.openitem98),
    #selector(AppDelegate.openitem99)
]

struct URLItem: Identifiable {
    let id: URL
    var icon: NSImage = NSImage(size: NSSize(width: 16, height: 16))
    init(url: URL) {
        id = url
    }
}

class LessClassicMenu {
    let preferencesName = "Classic Menu Items"
    
    var statusBarItem: NSStatusItem
    var menu: NSMenu
    var itemsDir: URL
    var items: Array<URLItem> = []
    var eventStream: FSEventStreamRef?
    
    init() {
        // Put our menu into the menu bar (right-hand side, not overlayed on the Apple menu)
        let statusBar = NSStatusBar.system
        statusBarItem = statusBar.statusItem(withLength: NSStatusItem.squareLength)
        // 'button' is only available in macOS 10.10 or newer
        statusBarItem.button?.image = NSImage(named: "rainbow")
        menu = NSMenu(title: "Less Classic Menu")
        statusBarItem.menu = menu
        
        // Find or create the folder where the user will put menu items
        let fm = FileManager.init()
        // 'homeDirectoryForCurrentUser' is only available in macOS 10.12 or newer
        let homeDir = fm.homeDirectoryForCurrentUser
        // 'init(fileURLWithPath:isDirectory:relativeTo:)' is only available in macOS 10.11 or newer
        itemsDir = URL(fileURLWithPath: "Library/Preferences/" + preferencesName,
                       isDirectory: true,
                       relativeTo: homeDir)
        if !fm.fileExists(atPath: itemsDir.path) {
            do {
                try fm.createDirectory(at: itemsDir, withIntermediateDirectories: false)
            } catch {
                // "\nERROR:" + error.localizedDescription
            }
        }
        
        // Add code to update menu from file system changes
        let pathsToWatch = [itemsDir.path]
        var context = FSEventStreamContext(version: 0,
                                           info: UnsafeMutableRawPointer(mutating: Unmanaged.passUnretained(self).toOpaque()),
                                           retain: nil, release: nil, copyDescription: nil)
        eventStream = FSEventStreamCreate(kCFAllocatorDefault, fsEventCallback, &context,
                                          pathsToWatch as CFArray,
                                          FSEventStreamEventId(kFSEventStreamEventIdSinceNow),
                                          0, FSEventStreamCreateFlags(kFSEventStreamCreateFlagUseCFTypes))!
        FSEventStreamScheduleWithRunLoop(eventStream!, RunLoop.current.getCFRunLoop(),
                                         CFRunLoopMode.defaultMode.rawValue)
        FSEventStreamStart(eventStream!)
        
        // Fill in the menu
        buildMenu()
    }
    
    func shutdown() {
        if let stream = eventStream {
            FSEventStreamStop(stream)
            FSEventStreamInvalidate(stream)
            FSEventStreamRelease(stream)
            eventStream = nil
        }
    }
    
    // This will be called when the user changes the contents of itemDir
    fileprivate let fsEventCallback: FSEventStreamCallback = { (stream, contextInfo, numEvents, eventPaths, eventFlags, eventIds) in
        
        let lcm: LessClassicMenu = unsafeBitCast(contextInfo, to: LessClassicMenu.self)
        let paths = unsafeBitCast(eventPaths, to: NSArray.self) as! [String]
        lcm.buildMenu()
    }
    
    func buildMenu() {
        menu.removeAllItems()
        items.removeAll()

        // Create a menu item for each alias in the Classic Menu Items folder
        let fm = FileManager.init()
        var index = 0
        if let files = try? fm.contentsOfDirectory(at: itemsDir, includingPropertiesForKeys: []) {
            func alphabetical(url1: URL, url2: URL) -> Bool {
                return url1.lastPathComponent < url2.lastPathComponent
            }
            for file in files.sorted(by: alphabetical) {
                if file.lastPathComponent.starts(with: ".") {
                    continue
                }
                var item: URLItem = URLItem(url: file)
                if var fw = try? FileWrapper(url: file) {
                    if fw.isSymbolicLink {  // Unfortunately false for aliases
                        if let dest = fw.symbolicLinkDestinationURL {
                            if let fw2 = try? FileWrapper(url: dest) {
                                fw = fw2
                            }
                        }
                    }
                    if let icon = fw.icon {
                        item.icon = icon
                        // Default icon is 32x32
                        // For some reason it does not work to resize the icon while building the menu
                        item.icon.size = NSSize(width: 16, height: 16)
                    }
                }
                items.append(item)
                if index < 100 {
                    let menuItem = NSMenuItem(title: fm.displayName(atPath: item.id.path),
                                              action: selectors[index],
                                              keyEquivalent: "")
                    menuItem.image = item.icon
                    menu.addItem(menuItem)
                }
                
                index = index + 1
            }
        }

        // The menu ends with the folder where the user will put menu items
        menu.addItem(NSMenuItem.separator())
        menu.addItem(NSMenuItem(title: preferencesName,
                                action: #selector(AppDelegate.openClassicMenuItems),
                                keyEquivalent: ""))
    }
}
